ASLA:   MACRO
%L      ASL     A
        ENDM
RORA:   MACRO
%L      ROR     A
        ENDM
LSRA:   MACRO
%L      LSR     A
        ENDM
ROLA:   MACRO
%L      ROL     A
        ENDM
LOCAL:  MACRO
        PROC
        ENDM
*
        .PAGE "SOME MISCELLANEOUS EQUATES"
*
MISCR1  EQU     $480        ; syntax check, etc.
;
ZFP     EQU     $D2         ; begin fltg point work area
;
FPORG   EQU     $D800       ; fltg point in OS ROMs
*
        .PAGE "ARGUMENT WORK AREA (AWA)"
*
*       FLOATING POINT WORK AREA
*
    ORG      ZFP
    DS     1
    DS     1
FPREC   EQU     6
FMPREC  EQU     FPREC-1     ; LENGTH OF FLOATING POINT
FR0     DS     1            ; FP REG0
FR0M    DS     FPREC-1      ; FP REG0 MANTISSA
;
FRE     DS     FPREC        ; FP REG0 EXP
;
FR1     DS     1            ; FP REG 1
FR1M    DS     FPREC-1      ; FP REG1 MANTISSA
;
FR2     DS     FPREC        ; FP REG 2
FRX     DS     1            ; FP SPARE
*
*       RAM FOR ASCII TO FLOATING POINT CONVERSION
*
EEXP    DS     1            ; VALUE OF E
FRSIGN                      ; FP SIGN
NSIGN   DS     1            ; SIGN OF #
PLYCNT
ESIGN   DS     1            ; SIGN OF EXPONENT
SGNFLG
FCHRFLG DS     1            ; 1ST CHAR FLAG
XFMFLG
DIGRT   DS     1            ; # OF DIGITS RIGHT OF DECIMAL
*
*       INPUT BUFFER CONTROLS
*
CIX     DS     1            ; CURRENT INPUT INDEX
INBUFF  DS     2            ; LINE INPUT BUFFER
*
*       TEMPS
*
ZTEMP1  DS     2            ; LOW LEVEL ZERO PageTEMPS
ZTEMP4  DS     2
ZTEMP3  DS     2
*
*       MISCELLANY
*
    DS     1
FLPTR   DS     2            ; POLYNOMIAL POINTERS
FPTR2   DS     2
*
*       MISCELLANEOUS NON-ZERO PAGE RAM
*
;               USED FOR VALUES NOT ACCESSED FREQUENTLY
    ORG     MISCR1
STACK   EQU     *           ; SYNTAX STACK
SIX     DS     1            ; INPUT INDEX
SOX     DS     1            ; OUTPUT INDEX
SPC     DS     2            ; PGM COUNTER
    ORG     STACK+254
LBPR1   DS     1            ; LBUFF PREFIX 1
LBPR2   DS     1            ; BLUFF PREFIX 2
LBUFF   DS     128          ; LINE BUFFER
    ORG     LBUFF+$60
PLYARG  DS     FPREC
FPSCR   DS     FPREC
FPSCR1  DS     FPREC
FSCR    EQU     FPSCR
FSCR1   EQU     FPSCR1
*
        .PAGE "FLOATING POINT"
*
    ORG     FPORG
    LOCAL
*
*       ASCIN — CONVERT ASCII INPUT TO INTERNAL FORM
*
*       ON ENTRY   INBUFF - POINTS TO BUFFER WITH ASCII
*                  CIX - INDEX TO 1ST BYTE OF #
*
*       ON EXIT    CC SET - CARRY SET IF NOT #
*                           CARRY CLEAR OF #
*
*
AFP
CVAFP
ASCIN
    JSR     SKPBLANK
    JSR     :TSTCHAR        ; SEE IF THIS COULD BE A NUMBER
    BCS     :NONUM          ; BR IF NOT A NUMBER
;
;       SET INITIAL VALUES
;
    LDX     #EEXP           ; ZERO 4 VALUES
    LDY     #4              ; X
    JSR     ZXLY            ; X
    LDX     #$FF
    STX     DIGRT           ; SET TO $FF
;
    JSR     ZFR0            ; CLEAR FR0
;
    BEQ     :IN2            ; UNCONDITIONAL BR
;
;
:IN1
    LDA     #$FF            ; SET 1ST CHAR TO NON ZERO
    STA     FCHRFLG         ; X
;
:IN2
    JSR     :GETCHAR        ; GET INPUT CHAR
    BCS     :NON1           ; BR IF CHAR NOT NUMBER
;
;
;       IT'S A NUMBER
;
    PHA                     ; SAVE ON CPU STACK
    LDX     FR0M            ; GET 1ST BYTE
    BNE     :INCE           ; INCR EXPONENT
;
    JSR     NIBSH0          ; SHIFT FR0 ONE NIBBLE LEFT
;
    PLA                     ; GET DIGIT ON CPU STACK
    ORA     FR0M+FMPREC-1   ; OR INTO LAST BYTE
    STA     FR0M+FMPREC-1   ; SAVE AS LAST BYTE
;
;       COUNT CHARACTERS AFTER DECIMAL POINT
;
    LDX     DIGRT           ; GET # OF DIGITS RIGHT
    BMI     :IN1            ; IF = $FF, NO DECIMAL POINT
    INX                     ; ADD IN THIS CHAR
    STX     DIGRT           ; SAVE
    BNE     :IN1            ; GET NEXT CHAR
;
;
;       INCREMENT # OR DIGIT MORE THAN 9
;
;
:INCE
    PLA                     ; CLEAR CPU STACK
    LDX     DIGRT           ; HAVE DP?
    BPL     :INCE2          ; IF YES, DON'T INCR E COUNT
    INC     EEXP            ; INCR EXPONENT
:INCE2
    JMP     :IN1            ; GET NEXT CHAR
;
;
:NONUM
    RTS                     ; RETURN FAIL
;
;       NON-NUMERIC IN NUMBER BODY
;
:NON1
    CMP     #'.'            ; IS IT DECIMAL POINT?
    BEQ     :DP             ; IF YES, PROCESS IT
    CMP     #'E'            ; IS IT E FOR EXPONENT?
    BEQ     :EXP            ; IF YES, DO EXPONENT
;
    LDX     FCHRFLG         ; IS THIS THE 1ST CHAR
    BNE     :EXIT           ; IF NOT, END OF NUMERIC INPUT
    CMP     #'+'            ; IS IT PLUS?
    BEQ     :IN1            ; GO FOR NEXT CHAR
    CMP     #'-'            ; IS IT MINUS?
    BEQ     :MINUS
;
;
:MINUS
    STA     NSIGN           ; SAVE SIGN FOR LATER
    BEQ     :IN1            ; UNCONDITIONAL BRANCH FOR NEXT CHAR
;
:DP
    LDX     DIGRT           ; IS DIGRT STILL = FF?
    BPL     :EXIT           ; IF NOT, ALREADY HAVE DP
    INX                     ; INCR TO ZERO
    STX     DIGRT           ; SAVE
    BEQ     :IN1            ; UNCONDITIONAL BR FOR NEXT CHAR
;
:EXP
    LDA     CIX             ; GET INDEX
    STA     FRX             ; SAVE
    JSR     :GETCHAR        ; GET NEXT CHAR
    BCS     :NON2           ; BR IF NOT NUMBER
;
;       IT'S A NUMBER IN AN EXPONENT
;
:EXP2
    TAX                     ; SAVE 1ST CHAR OF EXPONENT
    LDA     EEXP            ; GET # OF CHAR OVER 9
    PHA                     ; SAVE IT
    STX     EEXP            ; SAVE 1ST CHAR OF EXPONENT
    JSR     :GETCHAR        ; GET NEXT CHAR
;
;
    BCS     :EXP3           ; IF NOT # NO SECOND DIGIT
    PHA                     ; SAVE SECOND DIGIT
;
    LDA     EEXP            ; GET 1ST DIGIT
    ASLA                    ; GET DIGIT * 10
    STA     EEXP            ; X
    ASLA                    ; X
    ASLA                    ; X
    ADC     EEXP            ; X
    STA     EEXP            ; SAVE
    PLA                     ; GET SECOND DIGIT
    CLC
    ADC     EEXP            ; GET EXPONENT INPUTTED
    STA     EEXP            ; SAVE
;
    LDY     CIX             ; INC TO NEXT CHAR
    JSR     :GCHR1          ; X
;
;
:EXP3
    LDA     ESIGN           ; GET SIGN OF EXPONENT
    BEQ     :EXP1           ; IF NO SIGN, IT IS +
    LDA     EEXP            ; GET EXPONENT ENTERED
    EOR     #$FF            ; COMPLEMENT TO MAKE MINUS
    CLC                     ; X
    ADC     #1              ; X
    STA     EEXP            ; SAVE
:EXP1
    PLA                     ; GET # DIGITS MORE THAN 9
    CLC                     ; CLEAR CARRY
    ADC     EEXP            ; ADD IN ENTERED EXPONENT
    STA     EEXP            ; SAVE EXPONENT
    BNE     :EXIT           ; UNCONDITIONAL BR
;
;       NON-NUMERIC IN EXPONENT
;
:NON2
    CMP     #'+'            ; IS IT PLUS?
    BEQ     :EPLUS          ; IF YES BR
    CMP     #'-'            ; IS IT A MINUS?
    BNE     :NOTE           ; IF NOT, BR
;
;
:EMIN
    STA     ESIGN           ; SAVE EXPONENT SIGN
:EPLUS
    JSR     :GETCHAR        ; GET CHARACTER
    BCC     :EXP2           ; IF A #, GO PROCESS EXPONENT
;
;
;
;       E IS NOT PART OF OUR #
;
:NOTE
    LDA     FRX             ; POINT TO 1 PAST E
    STA     CIX             ; RESTORE CIX
;
;       FALL THRU TO EXIT
;
;       WHOLE # HAS BEEN INPUTTED
;
:EXIT
;
;       BACK UP ONE CHAR
;
    DEC     CIX             ; DECREMENT INDEX
;
;
;       CALCULATE POWER OF 10 = EXP - DIGITS RIGHT
;       WHERE EXP = ENTERED EXPONENT [COMPLEMENT OF -]
;               + # DIGITS MORE THAN 9
;
    LDA     EEXP            ; GET EXPONENT
    LDX     DIGRT           ; GET # DIGITS RIGHT OF DECIMAL
    BMI     :EXIT1          ; NO DECIMAL POINT
    BEQ     :EXIT1          ; # OF DIGITS AFTER D.P.=0
    SEC                     ; GET EXP - DIGITS RIGHT
    SBC     DIGRT           ; X
;
;       SHIFT RIGHT ALGEBRAIC TO DIVIDE BY 2 = POWER OF 100
;
:EXIT1
    PHA
    ROLA                    ; SET CARRY WITH SIGN OF EXPONENT
    PLA                     ; GET EXPONENT AGAIN
    RORA                    ; SHIFT RIGHT
    STA     EEXP            ; SAVE POWER OF 100
    BCC     :EVEN           ; IF NO CARRY # EVEN
;
    JSR     NIBSH0          ; ELSE SHIFT 1 NIBBLE LEFT
:EVEN
    LDA     EEXP            ; ADD 40 FOR EXCESS 64 + 4 FOR NORM
    CLC                     ; X
    ADC     #$44            ; X
    STA     FR0             ; SAVE AS EXPONENT
;
    JSR     NORM            ; NORMALIZE NUMBER
    BCS     :IND2           ; IF CARRY SET, IT'S AN ERROR
;
;       SET MANTISSA SIGH
;
    LDX     NSIGN           ; IS SIGN OF # MINUS?
    BEQ     :INDON          ; IF NOT, BR
;
    LDA     FR0             ; GET EXPONENT
    ORA     #$80            ; TURN ON MINUS # BIT
    STA     FR0             ; SET IN FR0 EXP
:INDON
    CLC                     ; CLEAR CARRY
:IND2
    RTS
*
*       FPASC — CONVERT FLOATING POINT TO ASCII
*
*       ON ENTRY   FR0 - # TO CONVERT
*
*       ON EXIT    INBUFF - POINTS TO START OF #
*                  HIGH ORDER BIT OF LAST BYTE IS ON
*
*
CVFASC
FASC
    JSR     INTLBF          ;SET INBUFF TO PT TO LBUFF
;
    LDA     #'0'            ; GET ASCII ZERO
    STA     LBUFF-1         ; PUT IN FRONT OF LBUFF
;
;       TEST FOR E FORMAT REQUIRED
;
    LDA     FR0             ; GET EXPONENT
    BEQ     :EXP0           ; IF EXP = 0, # = 0, SO BR
    AND     #$7F            ; AND OUT SIGN
    CMP     #$3F            ; IS IT LESS THAN 3F
    BCC     :EFORM          ; IF YES, E FORMAT REQUIRED
    CMP     #$45            ; IF IT IS > 44
    BCS     :EFORM          ; IF YES, E FORMAT REQUIRED
*
*       PROCESS NOT E FORMAT
*
    SEC                     ; SET CARRY
    SBC     #$3F            ; GET DECIMAL POSITION
;
    JSR     :CVFR0          ; CONVERT FR0 TO ASCII CHAR
;
    JSR     :FNZERO         ; FIND LAST NON-ZERO CHARACTER
    ORA     #$80            ; TURN ON HIGH ORDER BIT
    STA     LBUFF,X         ; STORE IT BACK IN BUFFER
;
    LDA     LBUFF           ; GET 1ST CHAR IN LBUFF
    CMP     #'.'            ; IS IT DECIMAL?
    BEQ     :FN6            ; BR IF YES
    JMP     :FN5            ; ELSE JUMP
:FN6
    JSR     :DECINB         ; DECIMAL INBUFF
    JMP     :FN4            ; DO FINAL ADJUSTMENT
*
*       EXPONENT IS ZERO - # IS ZERO
*
*
:EXP0
    LDA     #$80+$30        ; GET ASCII 0 WITH MSB = 1
    STA     LBUFF           ; PUT IN BUFFER
    RTS
*
*       PROCESS E FORMAT
*
:EFORM
    LDA     #1              ; GET DECIMAL POSITION
    JSR     :CVFR0          ; CONVERT FR0 TO ASCII IN LBUFF
;
    JSR     :FNZERO         ; GET RID OF TRAILING ZEROS
    INX                     ; INCR INDEX
    STX     CIX             ; SAVE INDEX TO LAST CHAR
;
;       ADJUST EXPONENT
;
    LDA     FR0             ; GET EXPONENT
    ASLA                    ; MULT BY 2 [GET RID OF SIGN TOO]
    SEC
    SBC     #$40*2          ; SUB EXCESS 64
;
    LDX     LBUFF           ; GET 1ST CHAR IN LBUFF
    CPX     #'0'            ; IS IT ASCII 0?
    BEQ     :EF1
;
;       PUT DECIMAL AFTER 1ST CHAR [IT'S AFTER 2ND NOW]
;
    LDX     LBUFF+1         ; SWITCH D.P. + 2ND DIGIT
    LDY     LBUFF+2         ; X
    STX     LBUFF+2         ; X
    STY     LBUFF+1         ; X
;
;
    LDX     CIX             ; IF CIX POINTS TO D.P.
    CPX     #2              ; THEN INC
    BNE     :NOINC          ; X
    INC     CIX             ; X
;
:NOINC
    CLC                     ; X
    ADC     #1              ; X
;
;       CONVERT EXP TO ASCII
;
:EF1
    STA     EEXP            ; SAVE EXPONENT
    LDA     #'E'            ; GET ASCII E
    LDY     CIX             ; GET POINTER
    JSR     :STCHAR         ; STORE CHARACTER
    STY     CIX             ; SAVE INDEX
;
;
    LDA     EEXP            ; GET EXPONENT
    BPL     :EPL            ; BR IF PLUS
;
;       EXPONENT IS MINUS - COMPLEMENT IT
;
    LDA     #0              ; SUBTRACT FROM 0 TO COMPLEMENT
    SEC                     ; X
    SBC     EEXP            ; X
    STA     EEXP
;
    LDA     #'-'            ; GET A MINUS
    BNE     :EF2
;
:EPL
    LDA     #'+'            ; GET A PLUS
:EF2
    JSR     :STCHAR         ; STORE A CHARACTER
;
    LDX     #0              ; SET COUNTER FOR # OF TENS
    LDA     EEXP            ; GET EXPONENT
;
:EF3
    SEC
    SBC     #10             ; SUBTRACT 10
    BCC     :EF4            ; IF < 0, BRANCH
    INX                     ; INCR # OF 10'S
    BNE     :EF3            ; BR INCONDITIONAL
;
:EF4
    CLC                     ; ADD BACK IN 10
    ADC     #10             ; X
    PHA                     ; SAVE
;
    TXA                     ; GET # OF 10'S
    JSR     :STNUM          ; PUT 10'S IN EXP IN BUFFER
    PLA                     ; GET REMAINDER
    ORA     #$80            ; TURN ON HIGH ORDER BIT
    JSR     :STNUM          ; PUT IN BUFFER
;
;       FINAL ADJUSTMENT
;
:FN5
    LDA     LBUFF           ; GET 1ST BYTE IN LBUFF [OUTPUT]
    CMP     #'0'            ; IS IT ASCII 0?
    BNE     :FN4            ; IF NOT BR
;
;       INCREMENT INBUFF TO POINT TO NON-ZERO
;
    CLC                     ; ADD 1 TO INBUFF
    LDA     INBUFF          ; X
    ADC     #1              ; X
    STA     INBUFF          ; X
    LDA     INBUFF+1        ; X
    ADC     #0              ; X
    STA     INBUFF+1        ; X
:FN4
    LDA     FR0             ; GET EXPONENT OF #
    BPL     :FADONE         ; IF SIGN +, WE ARE DONE
;
    JSR     :DECINB         ; DECR INBUFF
    LDY     #0              ; GET INDEX
    LDA     #'-'            ; GET ASCII -
    STA     [INBUFF],Y      ; SAVE - IN BUFFER
;
:FADONE
    RTS
*
*       IFP — CONVERT INTEGER TO FLOATING POINT
*
*       ON ENTRY   FR0 - CONTAINS INTEGER
*
*       ON EXIT    FR0 - CONTAINS FLOATING POINT #
*
*
CVIFP
IFP
;
;       MOVE INTEGER AND REVERSE BYTES
;
    LDA     FR0             ; GET INTEGER LOW
    STA     ZTEMP4+1        ; SAVE AS INTEGER HIGH
    LDA     FR0+1           ; GET INTEGER HIGH
    STA     ZTEMP4          ; SAVE AS INTEGER LOW
;
    JSR     ZFR0            ; CLEAR FR0
    SED                     ; SET DECIMAL MODE
*
*       DO THE CONVERT
*
    LDY     #16             ; GET # BITS IN INTEGER
:IFP1
    ASL     ZTEMP4+1        ; SHIFT LEFT INTEGER LOW
    ROL     ZTEMP4          ; SHIFT LEFT INTEGER HIGH
                            ; CARRY NOW SET IF THERE WAS A BIT
    LDX     #3              ; BIGGEST INTEGER IS 3 BYTES
:IFP2
;
;       DOUBLE # AND ADD IN 1 IF CARRY SET
;
    LDA     FR0,X           ; GET BYTE
    ADC     FR0,X           ; DOUBLE [ADDING IN CARRY FROM SHIFT
    STA     FR0,X           ; SAVE
    DEX                     ; DECREMENT COUNT OF FR0 BYTES
    BNE     :IFP2           ; IF MORE TO DO, DO IT
;
    DEY                     ; DECR COUNT OF INTEGER DIGITS
    BNE     :IFP1           ; IF MORE TO DO, DO IT
    CLD                     ; CLEAR DECIMAL MODE
;
;       SET EXPONENT
;
    LDA     #$42            ; INDICATE DECIMAL AFTER LAST DIGIT
    STA     FR0             ; STORE EXPONENT
;
    JMP     NORM            ; NORMALIZE
;
*
*       FPI — CONVERT FLOATING POINT TO INTEGER
*
*       ON ENTRY   FR0 - FLOATING POINT NUMBER
*
*       ON EXIT    FR0 - INTEGER
*
*
*       CC SET  CARRY CLEAR - NO ERROR
*               CARRY SET - ERROR
*
*
FPI
;
;       CLEAR INTEGER
;
    LDA     #0              ; CLEAR INTEGER RESULT
    STA     ZTEMP4
    STA     ZTEMP4+1
;
;       CHECK EXPONENT
;
    LDA     FR0             ; GET EXPONENT
    BMI     :ERVAL          ; IF SIGN OF FP# IS -, THEN ERROR
    CMP     #$43            ; IS FP# TOO BIG TO BE INTEGER
    BCS     :ERVAL          ; IF YES, THEN ERROR
    SEC                     ; SET CARRY
    SBC     #$40            ; IS FP# LESS THAN 1?
    BCC     :ROUND          ; IF YES, THEN GO TEST FOR ROUND
;
;       GET # OF DIGITS TO CONVERT = [EXPONENT -40+1]*2
;       [A CONTAINS EXPONENT -40]
;       [CARRY SET]
;
    ADC     #0              ; ADD IN CARRY
    ASLA                    ; MULT BY 2
    STA     ZTEMP1          ; SAVE AS COUNTER
*
*       DO CONVERT
*
:FPI1
;
;       MULT INTEGER RESULT BY 10
;
    JSR     :ILSHFT         ; GO SHIFT ONCE LEFT
    BCS     :ERVAL          ; IF CARRY SET THEN # TOO BIG
;
    LDA     ZTEMP4          ; SAVE INTEGER *2
    STA     ZTEMP3          ; X
    LDA     ZTEMP4+1        ; X
    STA     ZTEMP3+1        ; X
;
    JSR     :ILSHFT         ; MULT BY *2
    BCS     :ERVAL          ; # TOO BIG
    JSR     :ILSHFT         ; MULT BY *2 [NOW * 8 IN ZTEMP4]
    BCS     :ERVAL          ; BR IF # TOO BIG
;
    CLC                     ; ADD IN * 2 TO = *10
    LDA     ZTEMP4+1        ; X
    ADC     ZTEMP3+1        ; X
    STA     ZTEMP4+1        ; X
    LDA     ZTEMP4          ; X
    ADC     ZTEMP3          ; X
    STA     ZTEMP4          ; X
    BCS     :ERVAL          ; IF CARRY SET ERROR
;
;
;       ADD IN NEXT DIGIT
;
    JSR     :GETDIG         ; GET DIGIT IN A
    CLC
    ADC     ZTEMP4+1        ; ADD IN DIGIT
    STA     ZTEMP4+1        ; X
    LDA     ZTEMP4          ; X
    ADC     #0              ; X
    BCS     :ERVAL          ; BR IF OVERFLOW
    STA     ZTEMP4          ;X
;
    DEC     ZTEMP1          ; DEC COUNTER OF DIGITS TO DO
    BNE     :FPI1           ; IF MORE TO DO, DO IT
;
;       ROUND IF NEEDED
;
:ROUND
    JSR     :GETDIG         ; GET NEXT DIGIT IN A
    CMP     #5              ; IS DIGIT <5?
    BCC     :NR             ; IF YES, DON'T ROUND
    CLC                     ; ADD IN 1 TO ROUND
    LDA     ZTEMP4+1        ; X
    ADC     #1              ; X
    STA     ZTEMP4+1        ; X
    LDA     ZTEMP4          ; X
    ADC     #0              ; X
    STA     ZTEMP4          ; X
;
;       MOVE INTEGER TO FR0
;
:NR
    LDA     ZTEMP4+1        ; GET INTEGER LOW
    STA     FR0             ; SAVE
    LDA     ZTEMP4          ; GET INTEGER HIGH
    STA     FR0+1           ; SAVE
;
    CLC                     ; CLEAR CC FOR GOOD RETURN
    RTS
;
;
:ERVAL
    SEC                     ; SET CARRY FOR ERROR RETURN
    RTS
*       ZFR0 - ZERO FR0
*
*       ZF1 - ZERO 6 BYTES AT LOC X
*
*       ZXLY - ZERO PAGE ZERO LOC X FOR LENGTH Y
*
;
ZFR0
    LDX     #FR0            ; GET POINTER TO FR1
;
ZF1
    LDY     #6              ; GET # OF BYTES TO CLEAR
ZXLY
    LDA     #0              ; CLEAR A
:ZF2
    STA     0,X             ; CLEAR A BYTE
    INX                     ; POINT TO NEXT BYTE
    DEY                     ; DEC COUNTER
    BNE     :ZF2            ; LOOP
    RTS
;
;
;
;
;       INTLBF - INIT LBUFF INTO INBUFF
;
INTLBF
    LDA     #LBUFF/256
    STA     INBUFF+1
    LDA     #LBUFF&255
    STA     INBUFF
    RTS
*
*       :ILSHFT - SHIFT INTEGER IN ZTEMP4 LEFT ONCE
*
ILSHFT
:ILSHFT
    CLC                     ; CLEAR CARRY
    ROL     ZTEMP4+1        ; SHIFT LOW
    ROL     ZTEMP4          ; SHIFT HIGH
    RTS
*
        .PAGE "FLOATING POINT ROUTINES"
*
*       FADD — FLOATING POINT ADD ROUTINE
*
*               ADDS VALUES IN FR0 AND FR1
*
*       ON ENTRY   FR0 & FR1 - CONTAIN # TO ADD
*
*       ON EXIT    FR0 - RESULT
*
*       FSUB — FLOATING POINT SUBTRACT ROUTINE
*
*               SUBTRACTS FR1 FROM FR0
*
*       ON ENTRY   FR0 & FR1 - CONTAIN # TO SUBTRACT
*
*       ON EXIT    FR0 - RESULT
*
*       BOTH RETURN WITH CC SET:
*               CARRY SET IF ERROR
*               CARRY CLEAR IF NO ERROR
*
*
FSUB
    LDA     FR1             ; GET EXPONENT OF FR1
    EOR     #$80            ; CHANGE SIGN OF MANTISSA
    STA     FR1             ; SAVE EXPONENT
;
;
;
FADD
:FRADD
    LDA     FR1             ; GET EXPONENT FR1
    AND     #$7F            ; TURN OFF MANTISSA SIGN BIT
    STA     ZTEMP4          ; SAVE TEMPORARILY
    LDA     FR0             ; GET EXPONENT FR0
    AND     #$7F            ; TURN OFF MANTISSA SIGN BIT
    SEC                     ; CLEAR CARRY
    SBC     ZTEMP4          ; SUB EXPONENTS
    BPL     :NSWAP          ; IF EXP[FR0]>= EXP[FR1], NO SWAP
;
;       SWAP FR0 AND FR1
;
    LDX     #FMPREC         ; GET INDEX
;
:SWAP
    LDA     FR0,X           ; GET BYTE FROM FR0
    LDY     FR1,X           ; GET BYTE FROM FR1
    STA     FR1,X           ; PUT FR0 BYTE IN FR1
    TYA                     ; GET FR1 BYTE
    STA     FR0,X           ; PUT FR1 BYTE IN FR0
    DEX                     ; DEC INDEX
    BPL     :SWAP           ; IF MORE TO DO, GO SWAP
    BMI     :FRADD          ; UNCONDITIONAL
;
:NSWAP
    BEQ     :NALIGN         ; IF DIFFERENCE = 0, ALREADY ALIGNED
    CMP     #FMPREC         ; IS DIFFERENCE < # OF BYTES
    BCS     :ADDEND         ; IF NOT, HAVE RESULT IN FR0
;
;
    JSR     RSHFT1          ; SHIFT TO ALIGN
;
;       TEST FOR LIKE SIGN OF MANTISSA
;
:NALIGN
    SED                     ; SET DECIMAL MODE
    LDA     FR0             ; GET FR0 EXPONENT
    EOR     FR1             ; EOR WITH FR1 EXPONENT
    BMI     :SUB            ; IF SIGNS DIFFERENT - SUBTRACT
                            ; ELSE ADD
;
;       ADD FR0 & FR1
;
    LDX     #FMPREC-1       ; GET POINTER FOR LAST BYTE
    CLC                     ; CLEAR CARRY
:ADD1
    LDA     FR0M,X          ; GET BYTE OF FR0
    ADC     FR1M,X          ; ADD IN BYTE OF FR1
    STA     FR0M,X          ; STORE
    DEX                     ; DEC POINTER
    BPL     :ADD1           ; ADD NEXT BYTE
;
    CLD                     ; CLEAR DECIMAL MODE
    BCS     :ADD2           ; IF THERE IS A CARRY, DO IT
:ADDEND
    JMP     NORM            ; GO NORMALIZE
;
;       ADD IN FIND CARRY
;
:ADD2
    LDA     #1              ; GET 1 TIMES TO SHIFT
    JSR     RSHFT0          ; GO SHIFT
;
    LDA     #1              ; GET CARRY
    STA     FR0M            ; ADD IN CARRY
    JMP     NORM
;
;       SUBTRACT FR1 FROM FR0
;
:SUB
    LDX     #FMPREC-1       ; GET POINTER TO LAST BYTE
    SEC                     ; SET CARRY
;
:SUB1
    LDA     FR0M,X          ; GET FR0 BYTE
    SBC     FR1M,X          ; SUB FR1 BYTE
    STA     FR0M,X          ; STORE
    DEX                     ; DEC POINTER
    BPL     :SUB1           ; SUB NEXT BYTE
;
    BCC     :SUB2           ; IF THERE IS A BORROW DO IT
    CLD                     ; CLEAR DECIMAL MODE
    JMP     NORM
;
;       TAKE COMPLEMENT SIGN
;
:SUB2
    LDA     FR0             ; GET EXPONENT
    EOR     #$80            ; CHANGE SIGN OF MANTISSA
    STA     FR0             ; PUT IT BACK
;
;       COMPLEMENT MANTISSA
;
    SEC                     ; SET CARRY
    LDX     #FMPREC-1       ; GET INDEX COUNTER
:SUB3
    LDA     #0              ; GET ZERO
    SBC     FR0M,X          ; COMPLEMENT BYTE
    STA     FR0M,X          ; STORE
    DEX                     ; MORE TO DO
    BPL     :SUB3           ; BR IF YES
;
    CLD                     ; CLEAR DECIMAL MODE
    JMP     NORM            ; GO NORMALIZE
*
*       FMUL — MULTIPLY FR0 BY FR1
*
*       ON ENTRY   # ARE IN FR0 AND FR1
*
*       ON EXIT    FR0 - CONTAINS PRODUCT
*       RETURN WITH CC SET
*               CARRY SET IF ERROR
*               CARRY CLEAR IF NO ERROR
*
*
*
FMUL
;
;       SET UP EXPONENT
;
    LDA     FR0             ; GET EXP FR0
    BEQ     MEND3           ; IF = 0, DONE
    LDA     FR1             ; GET FR1 EXP
    BEQ     MEND2           ; IF =0, ANSWER =0
;
    JSR     MDESUP          ; DO COMMON SET FOR EXPONENT
    SEC                     ; SET CARRY
    SBC     #$40            ; SUB EXCESS 64
    SEC                     ; SET CARRY TO ADD 1
    ADC     FR1             ; ADD 1 + FR1 EXP TO FR0 EXP
    BMI     :EROV           ;IF - THEN OVERFLOW
;
;       FINISH MULTIPLY SET UP
;
    JSR     MDSUP           ; DO SET UP COMMON TO DIVIDE
;
*
*       DO THE MULTIPLY
*
:FRM
;
;       GET # OF TIMES TO ADD IN MULTIPLICAND
;
    LDA     FRE+FMPREC      ; GET LAST BYTE OF FRE
    AND     #$0F            ; AND OUT HIGH ORDER NIBBLE
    STA     ZTEMP1+1        ; SET COUNTER FOR LOOP CONTROL
;
;       ADD IN FR1
;
:FRM1
    DEC     ZTEMP1+1        ; DEC MULT COUNTER
    BMI     :FRM2           ; IF - THIS LOOP DONE
    JSR     FRA10           ; ADD FR1 TO FR0 [6 BYTES]
    JMP     :FRM1           ; REPEAT
;
;       GET # OF TIMES TO ADD IN MULTIPLICAND * 10
;
:FRM2
    LDA     FRE+FMPREC      ; GET LAST BYTE OF FRE
    LSRA                    ; SHIFT OUT LOW ORDER NIBBLE
    LSRA                    ; X
    LSRA                    ; X
    LSRA                    ; X
    STA     ZTEMP1+1        ; SAVE AS COUNTER
;
;       ADD IN FR2
;
:FRM3
    DEC     ZTEMP1+1        ; DECREMENT COUNTER
    BMI     :NXTB           ; IF -, DO NEXT BYTE
    JSR     FRA20           ; ADD FR2 TO FR0 [6 BYTES]
    JMP     :FRM3           ; REPEAT
;
;       SET UP FOR NEXT SET OF ADDS
;
:NXTB
;
;       SHIFT FR0/FRE RIGHT ONE BYTE
;               [THEY ARE CONTIGUOUS]
;
    JSR     RSHF0E          ;SHIFT FR0/FRE RIGHT
;
;       TEST FOR # OF BYTES SHIFTED
;
    DEC     ZTEMP1          ; DECREMENT LOOP CONTROL
    BNE     :FRM            ; IF MORE ADDS TO DO, DO IT
;
;       SET EXPONENT
;
MDEND
    LDA     EEXP            ; GET EXPONENT
    STA     FR0             ; STORE AS FR0 EXP
;
;
MEND1
    JMP     NORM1           ; NORMALIZE
;
;
;
MEND2
    JSR     ZFR0            ; CLEAR FR0
MEND3
    CLC                     ; CLEAR CARRY FOR GOOD RTN
    RTS
;
;
;
:EROV
    SEC                     ; SET CARRY FOR ERROR ROUTINE
    RTS                     ; RETURN
*
*       FDIV — FLOATING POINT DIVIDE
*
*       ON ENTRY   FR0 - DIVIDEND
*                  FR1 - DIVISOR
*
*       ON EXIT    FR0 - QUOTIENT
*
*       RETURNS WITH CC SET:
*               CARRY CLEAR - ERROR
*               CARRY SET - NO ERROR
*
*
FDIV
;
;       DO DIVIDE SET UP
;
    LDA     FR1             ; GET FR1 EXP
    BEQ     :EROV           ; IF =0, THEN OVERFLOW
    LDA     FR0             ; GET EXPONENT FR0
    BEQ     MEND3           ; IF = 0, THEN DONE
;
    JSR     MDESUP          ; DO COMMON PART OF EXP SET UP
;
    SEC
    SBC     FR1             ; SUB FR1 EXP FROM FR0 EX
    CLC
    ADC     #$40            ; ADD IN EXCESS 64
    BMI     :EROV           ; IF MINUS THEN OVERFLOW
;
    JSR     MDSUP           ; DO SETUP COMMON FOR MULT
    INC     ZTEMP1          ;LOOP 1 MORE TIME FOR DIVIDE
    JMP     :FRD1           ; SKIP SHIFT 1ST TIME THROUGH
;
QTEMP   EQU     FR0+FMPREC
:NXTQ
;
;       SHIFT FR0/FRE LEFT ONE BYTE
;               [THEY ARE CONTIGUOUS]
;
    LDX     #0              ; GET POINTER TO BYTE TO MOVE
:NXTQ1
    LDA     FR0+1,X         ; GET BYTE
    STA     FR0,X           ; MOVE IT LEFT ONE BYTE
;
    INX                     ; POINT TO NEXT BYTE
    CPX     #FMPREC*2+2     ; HAVE WE DONE THEM ALL?
    BNE     :NXTQ1          ; IF NOT, BRANCH
*
*       DO DIVIDE
*
:FRD1
;
;       SUBTRACT FR2 [DIVISOR * 2] FROM FRE [DIVIDEND]
;
;
    LDY     #FMPREC         ; SET LOOP CONTROL
    SEC                     ; SET CARRY
    SED                     ; SET DECIMAL MODE
:FRS2
    LDA     FRE,Y           ; GET A BYTE FROM FRE
    SBC     FR2,Y           ; SUB FR2
    STA     FRE,Y           ; STORE RESULT
    DEY                     ; DEC COUNTER
    BPL     :FRS2           ; BR IF MORE TO DO
    CLD                     ; CLEAR DECIMAL MODE
;
    BCC     :FAIL           ; IF RESULT <0 [FRE < FR2] BR
;
    INC     QTEMP           ; INCR # TIMES SUB [QUOTIENT]
;
    BNE     :FRD1           ; SUB AGAIN
;
;       SUBTRACT OF FR2 DIDN'T GO
;
:FAIL
    JSR     FRA2E           ; ADD FR2 BACK TO FR0
;
;       SHIFT LAST BYTE OF QUOTIENT ONE NIBBLE LEFT
;
    ASL     QTEMP           ; SHIFT 4 BITS LEFT
    ASL     QTEMP           ; X
    ASL     QTEMP           ; X
    ASL     QTEMP           ; X
:FRD2
;
;       SUBTRACT FR1 [DIVISOR] FROM FRE [DIVIDEND]
;
;
    LDY     #FMPREC         ; SET LOOP CONTROL
    SEC                     ; SET CARRY
    SED                     ; SET DECIMAL MODE
:FRS1
    LDA     FRE,Y           ; GET A BYTE FROM FRE
    SBC     FR1,Y           ; SUB FR1
    STA     FRE,Y           ; STORE RESULT
    DEY
    BPL     :FRS1           ; BR IF MORE TO DO
    CLD                     ; CLEAR DECIMAL MODE
;
    BCC     :FAIL2          ; IF RESULT < 0 [FRE < FR1] BR
;
    INC     QTEMP           ; INCR # TIMES SUB [QUOTIENT]
;
    BNE     :FRD2           ; SUB AGAIN
;
;       SUBTRACT OF FR1 DIDN'T GO
;
:FAIL2
    JSR     FRA1E           ; ADD FR1 BACK TO FR0
;
    DEC     ZTEMP1          ; DEC LOOP CONTROL
    BNE     :NXTQ           ; GET NEXT QUIOTIENT BYTE
;
    JSR     RSHF0E          ;SHIFT RIGHT FR0/FRE TO CLEAR EXP
    JMP     MDEND           ; JOIN MULT END UP CODE
*
*       :GETCHAR — TEST INPUT CHARACTER
*
*       ON ENTRY   INBUFF - POINTS TO BUFFER WITH INPUT
*                  CIX - POINTS TO CHAR IN BUFFER
*
*       ON EXIT    CIX - POINTS TO NEXT CHAR
*                  CC - CARRY CLEAR IF CHAR IS NUMBER
*                       CARRY SET IF CHAR NOT NUMBER
*
:GETCHAR
    JSR     TSTNUM          ; GO TEST FOR NUMBER
    LDY     CIX             ; GET CHARACTER INDEX
    BCC     :GCHR1          ; IF CHAR = NUM, SKIP
;
    LDA     [INBUFF],Y      ; GET CHARACTER
;
:GCHR1
    INY                     ; POINT TO NEXT CHAR
    STY     CIX             ; SAVE INDEX
    RTS
;
;SKPBLANK-SKIP BLANKS
;       STARTS AT CIX AND SCANS FOR NON BLANKS
;
SKBLANK
SKPBLANK
    LDY     CIX             ;GET CIX
    LDA     #$20            ;GET A BLANK
;
:SB1    CMP     [INBUFF],Y      ;IS CHAR A BLANK
    BNE     :SBRTS          ;BR IF NOT
    INY                     ;INC TO NEXT
    BNE     :SB1            ;GO TEST
;
:SBRTS  STY     CIX         ;SET NON BLANK INDEX
    RTS                     ;RETURN
;
; TSTNUM-TEST CHAR AT CIX FOR NUM
;       - RTNS CARRY SET IF NUM
TSTNUM
    LDY     CIX             ;GET INDEX
    LDA     [INBUFF],Y      ;AND GET CHAR
    SEC
    SBC     #$30            ;SUBTRACT ASCLT ZERO
    BCC     :TSNFAIL        ;BR CHAR<ASCLT ZERO
    CMP     #$0A            ;TEST GT ASCLT 9
    RTS                     ;DONE
*
*       :TSTCHAR — TEST TO SEE IF THIS CAN BE A NUMBER
*
*       ON EXIT    CC - CARRY SET IF NOT A #
*                       CARRY CLEAR IF A #
*
:TSTCHAR
    LDA     CIX             ; GET INDEX
    PHA                     ; SAVE IT
    JSR     :GETCHAR        ; GET CHAR
    BCC     :RTPASS         ; IF = #8 RETURN PASS
;
    CMP     #'.'            ; IF = D.P., OK SO FAR
    BEQ     :TSTN
    CMP     #'+'            ; IF = +8 OK SO FAR
    BEQ     :TSTN1
    CMP     #'-'            ; IF = -8 OK SO FAR
    BEQ     :TSTN1
;
;
:RTFAIL
    PLA                     ; CLEAR STACK
:TSNFAIL SEC                ;SET FAIL
    RTS
;
;
:TSTN1
    JSR     :GETCHAR        ; GET CHAR
    BCC     :RTPASS         ; IF #, RETURN PASS
    CMP     #'.'            ; IS IT D.P.
    BNE     :RTFAIL         ; IF NOT, RETURN FAIL
:TSTN
    JSR     :GETCHAR        ; ELSE GET NEXT CHAR
    BCC     :RTPASS         ; IF #, RETURN PASS
    BCS     :RTFAIL         ; ELSE, RETURN FAIL
;
;
:RTPASS
    PLA                     ; RESTORE CIX
    STA     CIX             ; X
    CLC                     ; CLEAR CARRY
    RTS                     ; RETURN PASS
*
*       NIBSH0 — SHIFT FR0 ONE NIBBLE LEFT
*
*       NIBSH2 - SHIFT FR2 ONE NIBBLE LEFT
*
NIBSH2
    LDX     #FR2+1          ; POINT TO 1ST MANTISSA BYTE
    BNE     :NIB1
;
NIBSH0
    LDX     #FR0M           ; POINT TO MANTISSA OF FR0
:NIB1
    LDY     #4              ; GET # OF BITS TO SHIFT
:NIBS
    CLC                     ; CLEAR CARRY
    ROL     4,X             ; ROLL
    ROL     3,X             ; X
    ROL     2,X             ; X
    ROL     1,X             ; X
    ROL     0,X             ; X
    ROL     FRX             ; SAVE SHIFTED NIBBLE
;
    DEY                     ; DEC COUNT
    BNE     :NIBS           ; IF NOT = 0, REPEAT
    RTS
*
*       NORM — NORMALIZE FLOATING POINT NUMBER
*
NORM
    LDX     #0              ; GET ZERO
    STX     FR0+FPREC       ; FOR ADD NORM SHIFT IN A ZERO
NORM1
    LDX     #FMPREC-1       ; GET MAX # OF BYTES TO SHIFT
    LDA     FR0             ; GET EXPONENT
    BEQ     :NDONE          ; IF EXP=0, # =0
:NORM
    LDA     FR0M            ; GET 1ST BYTE OF MANTISSA
    BNE     :TSTBIG         ; IF NOT = 0 THEN NO SHIFT
;
;       SHIFT 1 BYTE LEFT
;
    LDY     #0              ; GET INDEX FOR 1ST MOVE BYTE
:NSH
    LDA     FR0M+1,Y        ; GET MOVE BYTE
    STA     FR0M,Y          ; STORE IT
    INY
    CPY     #FMPREC         ; ARE WE DONE
    BCC     :NSH            ; IF NOT SHIFT AGAIN
;
;
;       DECREMENT EXPONENT
;
    DEC     FR0             ; DECREMENT EXPONENT
;
    DEX                     ; DEC COUNTER
    BNE     :NORM           ; DO AGAIN IF NEEDED
;
;
;
    LDA     FR0M            ; IS MANTISSA STILL 0
    BNE     :TSTBIG         ; IF NOT, SEE IF TOO BIG
    STA     FR0             ; ELSE ZERO EXP
    CLC
    RTS
;
:TSTBIG
    LDA     FR0             ; GET EXPONENT
    AND     #$7F            ; AND OUT SIGN BIT
    CMP     #49+64          ; IS IT < 49+64?
    BCC     :TSTUND         ; IF YES, TEST UNDERFLOW
    RTS                     ; SO RETURN
:TSTUND
    CMP     #-49+64         ; IS IT >=-49+64?
    BCS     :NDONE          ; IF YES, WE ARE DONE
    JSR     ZFR0            ; ELSE # IS ZERO
;
:NDONE
    CLC                     ; CLEAR CARRY FOR GOOD RETURN
    RTS
*
*       RSHFT0 — SHIFT FR0 RIGHT/INCREMENT EXPONENT
*
*       RSHFT1 — SHIFT FR1 RIGHT/INCREMENT EXPONENT
*
*       ON ENTRY   A - # OF PLACES TO SHIFT
*
*
RSHFT0
    LDX     #FR0            ; POINT TO FR0
    BNE     :RSH
;
RSHFT1
    LDX     #FR1            ; POINT TO FR1
;
:RSH
    STX     ZTEMP3          ; SAVE FR POINTER
    STA     ZTEMP4          ; SAVE # OF BYTES TO SHIFT
    STA     ZTEMP4+1        ; SAVE FOR LATER
;
:RSH2
    LDY     #FMPREC-1       ; GET # OF BYTES TO MOVE
:RSH1
    LDA     4,X             ; GET CHAR
    STA     5,X             ; STORE CHAR
    DEX                     ; POINT TO NEXT BYTE
    DEY                     ; DEC LOOP CONTROL
    BNE     :RSH1           ; IF MORE TO MOVE, DO IT
    LDA     #0              ; GET 1ST BYTE
    STA     5,X             ; STORE IT
;
    LDX     ZTEMP3          ; GET FR POINTER
    DEC     ZTEMP4          ; DO WE NEED TO SHIFT AGAIN?
    BNE     :RSH2           ; IF YES, DO IT
;
;       FIX EXPONENT
;
    LDA     0,X             ; GET EXPONENT
    CLC
    ADC     ZTEMP4+1        ; SUB # OF SHIFTS
    STA     0,X             ; SAVE NEW EXPONENT
    RTS
*
*       RSHF0E — SHIFT FR0/FRE 1 bYTE RIGHT [THEY ARE CONTIGUOUS]
*
RSHF0E
    LDX     #FMPREC*2       ; GET LOOP CONTROL
;
:NXTB1
    LDA     FR0,X           ; GET A BYTE
    STA     FR0+1,X         ; MOVE IT OVER 1
;
    DEX                     ; DEC COUNTER
    BPL     :NXTB1          ; MOVE NEXT BYTE
    LDA     #0              ; GET ZERO
    STA     FR0             ; SHIFT IT IN
    RTS
*
*       :CVFR0 — CONVERT EACH BYTE IN FR0 TO 2 CHARACTERS IN LBUFF
*
*       ON ENTRY   A - DECIMAL POINT POSITION
*
*
:CVFR0
    STA     ZTEMP4          ; SAVE DECIMAL POSITION
;
    LDX     #0              ; SET INDEX INTO FR0M
    LDY     #0              ; SET INDEX INTO OUTPUT LINE [LBUFF]
;
;       CONVERT A BYTE
;
:CVBYTE
    JSR     :TSTDP          ; PUT IN D.P. NOW?
:CVB1
    SEC                     ; DECREMENT DECIMAL POSITION
    SBC     #1              ; X
    STA     ZTEMP4          ; SAVE IT
;
;       DO 1ST DIGIT
;
    LDA     FR0M,X          ; GET FROM FR0
    LSRA                    ; SHIFT OUT LOW ORDER BITS
    LSRA                    ; TO GET 1ST DIGIT
    LSRA                    ; X
    LSRA                    ; X
    JSR     :STNUM          ; GO PUT # IN BUFFER
;
;       DO SECOND DIGIT
;
    LDA     FR0M,X          ; GET NUMBER FROM FR0
    AND     #$0F            ; AND OUT HIGH ORDER BITS
    JSR     :STNUM          ; GO PUT # IN BUFFER
;
    INX                     ; INCR FR0 POINTER
    CPX     #FMPREC         ; DONE LAST FR0 BYTE?
    BCC     :CVBYTE         ; IF NOT, MORE TO DO
;
;       PUT IN DECIMAL POINT NOW?
;
:TSTDP
    LDA     ZTEMP4          ; GET DECIMAL POSITION
    BNE     :TST1           ; IF NOT = 0 RTN
    LDA     #'.'            ; GET ASCII DECIMAL POINT
    JSR     :STCHAR         ; PUT D.P. IN BUFFER
:TST1
    RTS
*
*       :STNUM — PUT ASCII NUMBER IN LBUFF
*
*       ON ENTRY   A - DIGIT TO BE CONVERTED TO ASCII
*                      AND PUT IN LBUFF
*                  Y - INDEX IN LBUFF
*
*       :STCHAR — STORE CHARACTER IN A IN LBUFF
*
:STNUM
    ORA     #$30            ; CONVERT TO ASCII
:STCHAR
    STA     LBUFF,Y         ; PUT IN LBUFF
    INY                     ; INCR LBUFF POINTER
    RTS
*
*       :FNZERO — FIND LAST NON-ZERO CHARACTER IN LBUFF
*
*       ON EXIT    A - LAST CHAR
*                  X - POINT TO LAST CHAR
*
:FNZERO
    LDX     #10             ; POINT TO LAST CHAR IN LBUFF
;
:FN3
    LDA     LBUFF,X         ; GET THE CHARACTER
    CMP     #'.'            ; IS IT DECIMAL?
    BEQ     :FN1            ; IF YES, BR
    CMP     #'0'            ; IS IT ZERO?
    BNE     :FN2            ; IF NOT, BR
    DEX                     ; DECREMENT INDEX
    BNE     :FN3            ; UNCONDITIONAL BR
;
;
:FN1
    DEX                     ; DECREMENT BUFFER INDEX
    LDA     LBUFF,X         ; GET LAST CHAR
:FN2
    RTS
*
*       :GETDIG — GET NEXT DIGIT FROM FR0
*
*       ON ENTRY   FR0 - #
*
*       ON EXIT    A - DIGIT
*
*
:GETDIG
    JSR     NIBSH0          ; SHIFT FR0 LEFT ONE NIBBLE
;
    LDA     FRX             ; GET BYTE CONTAINING SHIFTED NIBBLE
    AND     #$0F            ; AND OUT HIGH ORDER NIBBLE
    RTS
*
*       :DECINB — DECREMENT INBUFF
*
:DECINB
    SEC                     ; SUBTRACT ONE FROM INBUFF
    LDA     INBUFF          ; X
    SBC     #1              ; X
    STA     INBUFF          ; X
    LDA     INBUFF+1        ; X
    SBC     #0              ; X
    STA     INBUFF+1        ; X
    RTS
*
*       MDESUP — COMMON SET-UP FOR MULTIPLY AND DIVIDE EXPONENT
*
*       ON EXIT    FR1 - FR1 EXP WITH OUT SIGN
*                  A - FR0 EXP WITHOUT SIGN
*                  FRSIGN - SIGN FOR QUOTIENT
*
MDESUP
    LDA     FR0             ; GET FR0 EXPONENT
    EOR     FR1             ; GET FR1 EXPONENT
    AND     #$80            ; AND OUT ALL BUT SIGN BIT
    STA     FRSIGN          ; SAVE SIGN
;
    ASL     FR1             ; SHIFT OUT SIGN IN FR1 EXP
    LSR     FR1             ; RESTORE FR1 EXP WITHOUT SIGN
    LDA     FR0             ; GET FR0 EXP
    AND     #$7F            ; AND OUT SIGN BIT
    RTS
*
*       MDSUP — COMMON SET-UP FOR MULTIPLY AND DIVIDE
*
*       ON ENTRY   A - EXPONENT
*                  CC - SET BY ADD OR SUB TO GET A
*
*
MDSUP
    ORA     FRSIGN          ; OR IN SIGN BIT
    STA     EEXP            ; SAVE EXPONENT FOR LATER
    LDA     #0              ; CLEAR A
    STA     FR0             ; CLEAR FR0 EXP
    STA     FR1             ; CLEAR FR0 EXP
;
;
    JSR     MVFR12          ; MOVE FR1 TO FR2
;
    JSR     NIBSH2          ; SHIFT FR2 1 NIBBLE LEFT
    LDA     FRX             ; GET SHIFTED NIBBLE
    AND     #$0F            ; AND OUT HIGH ORDER NIBBLE
    STA     FR2             ; STORE TO FINISH SHIFT
;
    LDA     #FMPREC         ; SET LOOP CONTROL
    STA     ZTEMP1          ; X
;
    JSR     MVFR0E          ; MOVE FR0 TO FRE
    JSR     ZFR0            ; CLEAR FR0
;
    RTS
;
*
*       FRA
*
*       FRA10 - ADD FR1 TO FR0 [6 BYTES]
*
*       FRA20 - ADD FR2 TO FR0 [6 BYTES]
*
*       FRA1E - ADD FR1 TO FRE
*
*       FRA2E - ADD FR2 TO FRE
*
FRA10
    LDX     #FR0+FMPREC     ; POINT TO LAST BYTE OF SUM
    BNE     :F1
;
FRA20
    LDX     #FR0+FMPREC
    BNE     :F2
;
FRA1E
    LDX     #FRE+FMPREC
:F1
    LDY     #FR1+FMPREC
    BNE     :FRA
FRA2E
    LDX     #FRE+FMPREC
:F2
    LDY     #FR2+FMPREC
;
;
:FRA
    LDA     #FMPREC         ; GET VALUE FOR LOOP CONTROL
    STA     ZTEMP4          ; SET LOOP CONTROL
    CLC                     ; CLEAR CARRY
    SED                     ; SET DECIMAL MODE
:FRA1
    LDA     0,X             ; GET 1ST BYTE OF
    ADC     0,Y             ; ADD
    STA     0,X             ; STORE
    DEX                     ; POINT TO NEXT BYTE
    DEY                     ; POINT TO NEXT BYTE
    DEC     ZTEMP4          ; DEC COUNTER
    BPL     :FRA1           ; IF MORE TO DO, DO IT
    CLD                     ; CLEAR DECIMAL MODE
    RTS
*
*       MVFR12 — MOVE FR1 TO FR2
*
MVFR12
    LDY     #FMPREC         ; SET COUNTER
:MV2
    LDA     FR1,Y           ; GET A BYTE
    STA     FR2,Y           ; STORE IT
;
    DEY                     ; DEC COUNTER
    BPL     :MV2            ; IF MORE TO MOVE, DO IT
    RTS
*
*       MVFR0E — MOVE FR0 TO FRE
*
MVFR0E
    LDY     #FMPREC
:MV1
    LDA     FR0,Y
    STA     FRE,Y
;
    DEY
    BPL     :MV1
    RTS
*
        .PAGE "POLYNOMIAL EVALUATION"
*
*       Y=A[0]+A[1]*X+A[2]*X**2+...+A[N]*X**N,N>0
*        =[[...[A[N]*X+A[N-1]]*X+...+A[2]]*X+A[1]]*X+A[0]
*       INPUT: X IN FR0, N+1 IN A-REG
*       REG [X,Y]->A[N]...A[0]
*       OUTPUT  Y IN FR0
*       USES FPTR2, PLYCNT, PLYARG
*       CALLS FST0R, FMOVE, FLD1R, FADD, FMUL
PLYEVL  STX     FPTR2       ;SAVE POINTER TO COEFF'S
    STY     FPTR2+1
    STA PLYCNT
    LDX     #PLYARG&$FF
    LDY     #PLYARG/$100
    JSR     FST0R           ;SAVE ARG
    JSR     FMOVE           ;ARG->FR1
    LDX     FPTR2
    LDY     FPTR2+1
    JSR     FLD0R           ;COEF->FR0 [INIT SUM]
    DEC     PLYCNT
    BEQ     PLYOUT          ;DONE ?
PLYEV1  JSR     FMUL        ; SUM * ARG
    BCS     PLYOUT          ; 0'FLOW
    CLC
    LDA     FPTR2           ;BUMP COEF POINTER
    ADC     #FPREC
    STA     FPTR2
    BCC     PLYEV2
    LDA     FPTR2+1         ;ACROSS PAGE
    ADC     #0
    STA     FPTR2+1
PLYEV2  LDX     FPTR2
    LDY     FPTR2+1
    JSR     FLD1R           ;GET NEXT COEF
    JSR     FADD            ;SUM*ARG + COEF
    BCS     PLYOUT          ; 0'FLOW
    DEC     PLYCNT
    BEQ     PLYOUT          ;DONE ?
    LDX     #PLYARG&$FF
    LDY     #PLYARG/$100
    JSR     FLD1R           ;GET ARG AGAIN
    BMI     PLYEV1          ; [=JMP]
PLYOUT  RTS
*
        .PAGE "FLOATING LOAD/STORE"
*
*       LOAD FR0 FROM [X,Y]  X=LSB, Y=MSB, USES FLPTR [PG0]
FLD0R   STX     FLPTR       ; SET FLPTR => [X,Y]
    STY     FLPTR+1
FLD0P   LDY     #FPREC-1    ;# BYTES ENTER HERE W/FLPTR SET
FLD01   LDA     [FLPTR],Y   ; MOVE
    STA     FR0,Y
    DEY
    BPL     FLD01           ; COUNT & LOOP
    RTS
*
*       LOAD FR1 FROM [X,Y] OR [FLPTR]
FLD1R   STX     FLPTR       ; FLPTR=>[X,Y]
    STY     FLPTR+1
FLD1P   LDY     #FPREC-1    ; # BYTES ENTER W/FLPTR SET
FLD11   LDA     [FLPTR],Y   ; MOVE
    STA     FR1,Y
    DEY
    BPL     FLD11           ; COUNT & LOOP
    RTS
*
*       STORE FR0 IN [X,Y] OR [FLPTR]
FST0R   STX     FLPTR
    STY     FLPTR+1
FST0P   LDY     #FPREC-1    ; ENTRY W/FLPTR SET
FST01   LDA     FR0,Y
    STA     [FLPTR],Y
    DEY
    BPL     FST01
    RTS
*
*       MOVE FR0 TO FR1
*
MV0TO1
FMOVE   LDX     #FPREC-1
FMOVE1  LDA     FR0,X
    STA     FR1,X
    DEX
    BPL     FMOVE1
    RTS
*
        .PAGE "EXP[X] AND EXP10[X]"
*
EXP     LDX     #LOG10E&$FF     ; E**X = 10**[X*LOG10[E]]
    LDY     #LOG10E/$100
    JSR     FLD1R
    JSR     FMUL
    BCS     EXPERR
EXP10   LDA     #0          ; 10**X
    STA     XFMFLG          ; CLEAR TRANSFORM FLAG
    LDA     FR0
    STA     SGNFLG          ; REMEMBER ARG SGN
    AND     #$7F            ; ; & MAKE PLUS
    STA     FR0
    SEC
    SBC     #$40
    BMI     EXP1            ; X<1 SO USE SERIES DIRECTLY
*       10**X = 10**[I+F] = [10**I] * [10**F]
    CMP     #FPREC-2
    BPL     EXPERR          ; ARG TOO BIG
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FST0R           ; SAVE ARG
    JSR     FPI             ; MAKE INTEGER
    LDA     FR0
    STA     XFMFLG          ; SAVE MULTIPLIER EXP IN XFORM
    LDA     FR0+1           ; CHECK MSB
    BNE     EXPERR          ; SHOULD HAVE NONE
    JSR     IFP             ; NOW TURN IT BACK TO FLPT
    JSR     FMOVE
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FLD0R           ; GET ARG BACK
    JSR     FSUB            ; ARG - INTEGER PART = FRACTION
*       NOW HAVE FRACTION PART OF ARG [F] IN FR0,
*       INTEGER PART [I]
*       IN XFMFLG.  USE SERIES APPROX FOR
*       10**F, THEN MULTIPLY BY 10**I
EXP1
    LDA     #NPCOEF
    LDX     #P10COF&$FF
    LDY     #P10COF/$100
    JSR     PLYEVL          ;P[X]
    JSR     FMOVE
    JSR     FMUL            ;P[X]*P[X]
    LDA     XFMFLG          ; DID WE TRANSFORM ARG
    BEQ     EXPSGN          ; NO SO LEAVE RESULT ALONE
    CLC
    RORA                    ; I/2
    STA     FR1             ; SAVE AS EXP-TO-BE
    LDA     #1              ; GET MANTISSA BYTE
    BCC     EXP2            ; CHECK BIT SHIFTED OUT OF A
    LDA     #$10            ; I WAS ODD - MANTISSA = 10
EXP2    STA     FR1+1
    LDX     #FPREC-2
    LDA     #0
EXP3    STA     FR1+2,X     ; CLEAR REST OF MANTISSA
    DEX
    BPL     EXP3
    LDA     FR1             ; BACK TO EXPONENT
    CLC
    ADC     #$40            ; BIAS IT
    BCS     EXPERR          ; OOPS...IT'S TOO BIG
    BMI     EXPERR
    STA     FR1             ; FR1 = 10**I
    JSR     FMUL            ; [10**I]*[10**F]
EXPSGN  LDA     SGNFLG      ; WAS ARG<0
    BPL     EXPOUT          ; NO-DONE
    JSR     FMOVE           ; YES-INVERT RESULT
    LDX     #FONE&$FF
    LDY     #FONE/$100
    JSR     FLD0R
    JSR     FDIV
EXPOUT  RTS                 ; [PANT, PANT - FINISHED::]
EXPERR  SEC                 ; FLAG ERROR
    RTS                     ; & QUIT
P10COF  .BYTE   $3D,$17,$94,$19,0,0 ;0.0000179419
    .BYTE   $3D,$57,$33,$05,0,0 ;0.0000573305
    .BYTE   $3E,$05,$54,$76,$62,0 ;0.0005547662
    .BYTE   $3E,$32,$19,$62,$27,0 ;0.0032176227
    .BYTE   $3F,$01,$68,$60,$30,$36 ;0.0168603036
    .BYTE   $3F,$07,$32,$03,$27,$41 ;0.0732032741
    .BYTE   $3F,$25,$43,$34,$56,$75 ;0.2543345675
    .BYTE   $3F,$66,$27,$37,$30,$50 ;0.6627373050
    .BYTE   $40,$01,$15,$12,$92,$55 ;1.15129255
    .BYTE   $3F,$99,$99,$99,$99,$99 ;0.999999999
NPCOEF  EQU     (*-P10COF)/FPREC
LOG10E  .BYTE   $3F,$43,$42,$94,$48,$19  ; LOG10[E]
FONE    .BYTE   $40,1,0,0,0,0   ; 1.0
*
        .PAGE "Z=[X-C]/[X+C]"
*
XFORM   STX     FPTR2
    STY     FPTR2+1
    LDX     #PLYARG&$FF
    LDY     #PLYARG/$100
    JSR     FST0R           ;STASH X IN PLYARG
    LDX     FPTR2
    LDY     FPTR2+1
    JSR     FLD1R
    JSR     FADD            ;X+C
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FST0R
    LDX     #PLYARG&$FF
    LDY     #PLYARG/$100
    JSR     FLD0R
    LDX     FPTR2
    LDY     FPTR2+1
    JSR     FLD1R
    JSR     FSUB            ;X-C
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FLD1R
    JSR     FDIV            ; [X-C]/[X+C] = Z
    RTS
*
        .PAGE "LOG10[X]"
*
LOG     LDA     #1          ;REMEMBER ENTRY POINT
    BNE     LOGBTH
LOG10   LDA     #0          ; CLEAR FLAG
LOGBTH  STA     SGNFLG      ; USE SGNFLG FOR LOG/LOG10 MARKER
    LDA     FR0
    BPL     LOG5
LOGERR  SEC
    RTS
LOG5
*       WE WANT X = F*[10**Y], 1<F<10
*       10**Y HAS SAME EXP BYTE AS X
*       & MANTISSA BYTE = 1 OR 10
LOG1    LDA     FR0
    STA     FR1
    SEC
    SBC     #$40
    ASLA
    STA     XFMFLG          ; REMEMBER Y
    LDA     FR0+1
    AND     #$F0
    BNE     LOG2
    LDA     #1
    BNE     LOG3
LOG2    INC     XFMFLG      ; BUMP Y
    LDA     #$10
LOG3    STA     FR1+1       ; SET UP MANTISSA
    LDX     #FPREC-2        ; CLEAR REST OF MANTISSA
    LDA     #0
LOG4    STA     FR1+2,X
    DEX
    BPL     LOG4
    JSR     FDIV            ; X = X/[10**Y] - S.B. IN [1,10]
FLOG10                      ;;LOG10[X],1<=X<=10
    LDX     #SQR10&$FF
    LDY     #SQR10/$100
    JSR     XFORM           ;Z = [X-C]/[X+C],C*C = 10
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FST0R           ;SAVE Z
    JSR     FMOVE
    JSR     FMUL            ; Z*Z
    LDA     #NLCOEF
    LDX     #LGCOEF&$FF
    LDY     #LGCOEF/$100
    JSR     PLYEVL          ; P[Z*Z]
    LDX     #FPSCR&$FF
    LDY     #FPSCR/$100
    JSR     FLD1R
    JSR     FMUL            ; Z*P[Z*Z]
    LDX     #FHALF&$FF
    LDY     #FHALF/$100
    JSR     FLD1R
    JSR     FADD            ; 0.5 + Z*P[Z*Z]
    JSR     FMOVE
    LDA     #0
    STA     FR0+1
    LDA     XFMFLG
    STA     FR0
    BPL     LOG6
    EOR     #-1             ; FLIP SIGN
    CLC
    ADC     #1
    STA     FR0
LOG6
    JSR     IFP             ; LEAVES FR1 ALONE
    BIT     XFMFLG
    BPL     LOG7
    LDA     #$80            ; FLIP AGAIN
    ORA     FR0
    STA     FR0
LOG7
    JSR     FADD            ; LOG[X] = LOG[X] +Y
LOGOUT
    LDA     SGNFLG
    BEQ     LOGDON          ;WAS LOG10, NOT LOG
    LDX     #LOG10E&255     ; LOG[X]/LOG10[E]
    LDY     #LOG10E/$100
    JSR     FLD1R
    JSR     FDIV
LOGDON  CLC
    RTS
SQR10   .BYTE   $40,$03,$16,$22,$77,$66 ;SQUARE ROOT OF 10
FHALF   .BYTE   $3F,$50,0,0,0,0     ; 0.5
LGCOEF  .BYTE   $3F,$49,$15,$57,$11,$08 ;0.4915571108
    .BYTE   $BF,$51,$70,$49,$47,$08 ;-0.5170494708
    .BYTE   $3F,$39,$20,$57,$61,$95 ;0.3920576195
    .BYTE   $BF,$04,$39,$63,$03,$55 ;-0.0439630355
    .BYTE   $3F,$10,$09,$30,$12,$64 ;0.1009301264
    .BYTE   $3F,$09,$39,$08,$04,$60   ; 0.0939080460
    .BYTE   $3F,$12,$42,$58,$47,$42 ;0.1242584742
    .BYTE   $3F,$17,$37,$12,$06,$08   ; 0.1737120608
    .BYTE   $3F,$28,$95,$29,$71,$17 ;0.28957117
    .BYTE   $3F,$86,$85,$88,$96,$44 ;0.8685889644
NLCOEF  EQU     (*-LGCOEF)/FPREC
ATCOEF  .BYTE   $3E,$16,$05,$44,$49,0 ;0.0016054449
    .BYTE   $BE,$95,$68,$38,$45,0 ;-0.009568345
    .BYTE   $3F,$02,$68,$79,$94,$16 ;0.0268799416
    .BYTE   $BF,$04,$92,$78,$90,$80 ;-0.0492789080
    .BYTE   $3F,$07,$03,$15,$20,0 ;0.0703152000
    .BYTE   $BF,$08,$92,$29,$12,$44 ;-0.0892291244
    .BYTE   $3F,$11,$08,$40,$09,$11 ;0.1108400911
    .BYTE   $BF,$14,$28,$31,$56,$04 ;-0.1428315604
    .BYTE   $3F,$19,$99,$98,$77,$44 ;0.1999987744
    .BYTE   $BF,$33,$33,$33,$31,$13   ; -0.3333333113
FP9S    .BYTE   $3F,$99,$99,$99,$99,$99  ; 0.999999999
NATCF   EQU     (*-ATCOEF)/FPREC
PIOV4   .BYTE   $3F,$78,$53,$98,$16,$34 ; PI/4 = ARCTAN[1.0]
